function setCanvasSize(pageWidth,pageHeight) {
    var canvas = document.getElementById("canvas");
    canvas.width = pageWidth;
    canvas.height = pageHeight;
}

function drawPageBackgroud(pageWidth,pageHeight,bgColor) {
    var canvas = document.getElementById("canvas");
    var context = canvas.getContext("2d");
    context.save();
    context.fillStyle = bgColor;
    context.fillRect(0, 0, pageWidth,pageHeight);
    context.restore();
}

function drawPagePattern(pageWidth,pageHeight,imgPath,fitShape) {
    var canvas = document.getElementById("canvas");
    var context = canvas.getContext("2d");
    context.save();
    var img = new Image();
    img.src = imgPath;
    if(fitShape){
        img.onload = function() {
            context.drawImage(img, 0, 0, pageWidth,pageHeight);
        }
    }else{
        img.onload = function() {
            // 创建图案
            var ptrn = context.createPattern(img, 'repeat');
            context.fillStyle = ptrn;
            context.fillRect(0, 0, pageWidth, pageHeight);
        }
    }
    context.restore();
}

function saveCanvas(){
    var context = document.getElementById("canvas").getContext("2d");
    context.save();
}

function restoreCanvas(){
    var context = document.getElementById("canvas").getContext("2d");
    context.restore();
}

function transformCanvas(scaleX,skewX,skewY,scaleY,transX,transY){
    var context = document.getElementById("canvas").getContext("2d");
    context.transform(scaleX,skewX,skewY,scaleY,transX,transY);
}
function transformCanvas(trans){
    var context = document.getElementById("canvas").getContext("2d");
    context.transform(trans[0],trans[1],trans[3],trans[4],trans[2],trans[5]);
}

function scaleCanvas(scaleX,scaleY){
    var context = document.getElementById("canvas").getContext("2d");
    context.scale(scaleX,scaleY);
}

function translateCanvas(tranX,tranY){
    var context = document.getElementById("canvas").getContext("2d");
    context.translate(tranX,tranY);
}

function drawFillPath(svgPath,color){
    var context = document.getElementById("canvas").getContext("2d");
    context.save();
    context.fillStyle=color;
    var path = new Path2D(svgPath);
    context.fill(path);
    context.restore();
}

// lineCap :butt/round/square
// lineJoin :bevel/round/miter
function drawStrokePath(svgPath,color,mlineCap,mLineJoin,mlineWidth,mld){
    var context = document.getElementById("canvas").getContext("2d");
    context.save();
    context.lineCap=mlineCap;
    context.lineJoin=mLineJoin;
    context.lineWidth=mlineWidth;

    try {
        tmpstr = JSON.stringify(mld);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        mLineDash = substr.split(',');

        context.setLineDash(mLineDash);
    }catch(exception) {
       
    }
   
    var path = new Path2D(svgPath);
    context.strokeStyle=color;
    context.stroke(path);
    context.restore();
}

function drawLinearFillPath(svgPath,x1,y1,x2,y2,posArr,colorArr){
    var posArray;
    var colorArray;
    try {
        tmpstr = JSON.stringify(posArr);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        posArray = substr.split(',');

        tmpstr = JSON.stringify(colorArr);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        colorArray = substr.split(',');
    }catch(exception) {
       
    }
    var context = document.getElementById("canvas").getContext("2d");
    context.save();
    var path = new Path2D(svgPath);
    var lineargradient = context.createLinearGradient(x1,y1,x2,y2);
    for(var i=0;i<posArray.length;i++){
        lineargradient.addColorStop(posArray[i],colorArray[i]);
    }
    context.fillStyle = lineargradient;
    context.fill(path);
    context.restore();
    return posArray;
}

function drawLinearStrokePath(svgPath,x1,y1,x2,y2,posArr,colorArr,mlineCap,mLineJoin,mlineWidth,mld){
    var posArray;
    var colorArray;
    try {
        tmpstr = JSON.stringify(posArr);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        posArray = substr.split(',');

        tmpstr = JSON.stringify(colorArr);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        colorArray = substr.split(',');
    }catch(exception) {
       
    }

    var context = document.getElementById("canvas").getContext("2d");
    context.save();
    context.lineCap=mlineCap;
    context.lineJoin=mLineJoin;
    context.lineWidth=mlineWidth;

    try {
        tmpstr = JSON.stringify(mld);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        mLineDash = substr.split(',');

        context.setLineDash(mLineDash);
    }catch(exception) {
       
    }

    var path = new Path2D(svgPath);
    var lineargradient = context.createLinearGradient(x1,y1,x2,y2);
    for(var i=0;i<posArray.length;i++){
        lineargradient.addColorStop(posArray[i],colorArray[i]);
    }
    context.strokeStyle = lineargradient;
    context.stroke(path);
    context.restore();
}


function drawRadiaFillPath(svgPath,x1,y1,r1,x2,y2,r2,posArr,colorArr){
    var posArray;
    var colorArray;
    try {
        tmpstr = JSON.stringify(posArr);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        posArray = substr.split(',');

        tmpstr = JSON.stringify(colorArr);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        colorArray = substr.split(',');
    }catch(exception) {
       
    }

    var context = document.getElementById("canvas").getContext("2d");
    context.save();
    var path = new Path2D(svgPath);
    var radgrad  = context.createRadialGradient(x1,y1,r1,x2,y2,r2);
    for(var i=0;i<posArray.length;i++){
        radgrad.addColorStop(posArray[i],colorArray[i]);
    }
    context.fillStyle = radgrad;
    context.fill(path);
    context.restore();
}

function drawRadiaStrokePath(svgPath,x1,y1,r1,x2,y2,r2,posArr,colorArr,mlineCap,mLineJoin,mlineWidth,mld){
    var posArray;
    var colorArray;
    try {
        tmpstr = JSON.stringify(posArr);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        posArray = substr.split(',');

        tmpstr = JSON.stringify(colorArr);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        colorArray = substr.split(',');
    }catch(exception) {
       
    }

    var context = document.getElementById("canvas").getContext("2d");
    context.save();

    context.lineCap=mlineCap;
    context.lineJoin=mLineJoin;
    context.lineWidth=mlineWidth;

    try {
        tmpstr = JSON.stringify(mld);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        mLineDash = substr.split(',');

        context.setLineDash(mLineDash);
    }catch(exception) {
       
    }
    var path = new Path2D(svgPath);
    var radgrad  = context.createRadialGradient(x1,y1,r1,x2,y2,r2);
    for(var i=0;i<posArray.length;i++){
        radgrad.addColorStop(posArray[i],colorArray[i]);
    }
    context.strokeStyle = radgrad ;
    context.stroke(path);
    context.restore();
}

function drawFillHatch(imgPath,svgPath){
    var context = document.getElementById("canvas").getContext("2d");
    context.save();
    var path = new Path2D(svgPath);
    var img = new Image();
    img.src = imgPath;
    img.onload = function() {
        // 创建图案
        var ptrn = context.createPattern(img, 'repeat');
        context.fillStyle = ptrn;
        context.fill(path);
    }
    context.restore();
}

function drawStrokeHatch(imgPath,svgPath,mlineCap,mLineJoin,mlineWidth,mld){
    var context = document.getElementById("canvas").getContext("2d");
    context.save();
    context.lineCap=mlineCap;
    context.lineJoin=mLineJoin;
    context.lineWidth=mlineWidth;

    try {
        tmpstr = JSON.stringify(mld);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        mLineDash = substr.split(',');

        context.setLineDash(mLineDash);
    }catch(exception) {
       
    }
    var path = new Path2D(svgPath);
    var img = new Image();
    img.src = imgPath;
    img.onload = function() {
        // 创建图案
        var ptrn = context.createPattern(img, 'repeat');
        context.strokeStyle = ptrn;
        context.stroke(path);
    }
    context.restore();
}

function drawImg(imgPath,matValues){
    var context = document.getElementById("canvas").getContext("2d");
    context.save();
    var img = new Image();
    img.src = imgPath;
    if(fitShape){
        img.onload = function() {
            context.drawImage(img,0,0,pageWidth,pageHeight);
        }
    }else{
        img.onload = function() {
            // 创建图案
            var ptrn = context.createPattern(img, 'repeat');
            context.fillStyle = ptrn;
            context.fillRect(0, 0, pageWidth, pageHeight);
        }
    }
    context.restore();
}

function drawText(str,x,y,maxWidth){
    var context = document.getElementById("canvas").getContext("2d");
    context.save();
    try {
        tmpstr = JSON.stringify(matValues);
        substr = tmpstr.substring(2,tmpstr.length-2);
        trans = substr.split(',');
        context.font = "48px serif";
        for(var i=0;i<trans.length;i++){
            context.wrapText(trans[i], 10+i*80, 50);
        }
    }catch(exception) {
        alert(exception);
    }
    context.restore();
}

CanvasRenderingContext2D.prototype.wrapText = function (text, x, y, maxWidth, lineHeight) {
    if (typeof text != 'string' || typeof x != 'number' || typeof y != 'number') {
        return;
    }
    
    var context = this;
    var canvas = context.canvas;
    
    if (typeof maxWidth == 'undefined') {
        maxWidth = (canvas && canvas.width) || 300;
    }
    if (typeof lineHeight == 'undefined') {
        lineHeight = (canvas && parseInt(window.getComputedStyle(canvas).lineHeight)) || parseInt(window.getComputedStyle(document.body).lineHeight);
    }
    
    // 字符分隔为数组
    var arrText = text.split('');
    var line = '';
    context.save();
    for (var n = 0; n < arrText.length; n++) {
        var testLine = line + arrText[n];
        var metrics = context.measureText(testLine);
        var testWidth = metrics.width;
        if (testWidth > maxWidth && n > 0) {
            context.fillText(line, x, y);
            line = arrText[n];
            y += lineHeight;
        } else {
            line = testLine;
        }
    }
    context.fillText(line, x, y);
    context.restore();
};

function test(matValues){
    var context = document.getElementById("canvas").getContext("2d");
    context.save();
    try {
        tmpstr = JSON.stringify(matValues);
        substr = tmpstr.substring(2,tmpstr.length - 2);
        trans = substr.split(',');
        context.font = "48px serif";
        for(var i=0;i<trans.length;i++){
            context.fillText(trans[i], 10+i*80, 50);
        }
    }catch(exception) {
        alert(exception);
    }
    context.restore();
}