function convert(formula) {
    var output = document.getElementById('output');
    output.innerHTML = '';
    MathJax.texReset();
    var options = MathJax.getMetricsFor(output);
    options.display = false;
    MathJax.tex2svgPromise(formula, options).then(function (node) {
        var outputWidth = parseInt(output.offsetWidth);
        var svg = node.firstElementChild;
        const errorNode = svg.querySelector('g[data-mml-node="merror"]');
        if (errorNode) {
            window.js2java.result(-1, 'LaTex表达式语法错误，请检查！', 1);
        } else {
            window.js2java.result(1, svg.outerHTML, outputWidth);
        }
        MathJax.startup.document.clear();
        MathJax.startup.document.updateDocument();
    }).catch(function (err) {
        window.js2java.result(-1, err.message, 1);
        output.appendChild(document.createElement('pre')).appendChild(document.createTextNode(err.message));
    }).then(function () {
        window.js2java.result(2, '', 1);
    });
}

function setSvg(svg, showWidth, showHeight) {
    var output = document.getElementById('output');
    output.innerHTML = svg;
    // output.width = showWidth;
    output.style.width = showWidth + 'px';
    output.style.height = showHeight + 'px';
    return 'success';
}


// function saveFile(data, filename) {
//     var save_link = document.createElementNS(
//         'http://www.w3.org/1999/xhtml', 'a');
//     save_link.href = data;
//     save_link.download = filename;
//     var event = document.createEvent('MouseEvents');
//     event.initMouseEvent('click', true, false, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
//     save_link.dispatchEvent(event);
// };